/* 	ColumnModelTest.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: May 4, 2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.sql.meta;

/** Testcase for ColumnModel
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 1.00 [May 5, 2007]
 * @see org.brains2b.sql.meta.ColumnModel
 */
import java.sql.SQLException;
import java.sql.Types;
import java.util.List;

import org.brains2b.sql.meta.ColumnModel;
import org.brains2b.sql.meta.SQLMetaData;

public class ColumnModelTest extends ConnectedTestCase {

    public ColumnModelTest(String arg0) {
        super(arg0);
    }

    public void testConstructor() {
        try {
            SQLMetaData meta = new SQLMetaData(getConnector().getConnection());
            List l= meta.getColumns(null, getConnector().getUser(), "PERSON",null);
            ColumnModel cmId    = (ColumnModel) l.get(0);
            ColumnModel cmFirstName  = (ColumnModel) l.get(1);
            ColumnModel cmDate  = (ColumnModel) l.get(3);
            
            assertEquals(9, cmId.getColumnSize());
            assertEquals(Types.DECIMAL, cmId.getDataType());
            assertEquals(0, cmId.getDecimalDigits());
            assertNull(cmId.getDefault());
            assertEquals("ID", cmId.getName());
            assertTrue(!cmId.isNullable());
            assertNull(cmId.getRemarks());
            assertEquals(1, cmId.getSequence());
            
            assertEquals("FIRSTNAME", cmFirstName.getName());
            assertTrue(cmFirstName.isNullable());
            assertEquals(2, cmFirstName.getSequence());
            
            assertEquals(Types.TIMESTAMP,cmDate.getDataType());
            assertEquals(4, cmDate.getSequence());
            
        } catch (SQLException sqex) {
            assertTrue(sqex.getMessage(), false);
        }
        
    }
}
