/* 	SelectDescriptorTest.java
 *	Copyright (c) 2006, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Oct 14, 2006
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.sql.meta;

import org.brains2b.sql.meta.SelectDescriptor;

import junit.framework.TestCase;

public class SelectDescriptorTest extends TestCase {

	public SelectDescriptorTest(String arg0) {
		super(arg0);
	}

	public void testSimple() {
		SelectDescriptor sd= new SelectDescriptor("SELECT ID,NAME FROM COURSE");
		assertEquals("SELECT ID,NAME ", sd.getColumns());
		assertEquals("FROM COURSE", sd.getFrom());
        assertNull(sd.getWhere());
	}
    
    public void testAll() {
        String sql = 
            "select p.firstname, p.name, avg(m.grade) from person p,course c,program m " +
            "where p.id=m.person and c.id=m.course " +
            "group by p.firstname, p.name " +
            "having avg(m.grade)> 3.89 " +
            "order by avg(m.grade)";
        SelectDescriptor sd= new SelectDescriptor(sql);
        assertEquals(sql,sd.toString());
        assertEquals("select p.firstname, p.name, avg(m.grade) ", sd.getColumns());
        assertEquals("from person p,course c,program m ", sd.getFrom());
        assertEquals("where p.id=m.person and c.id=m.course ", sd.getWhere());
        assertEquals("group by p.firstname, p.name ", sd.getGroupBy());
        assertEquals("having avg(m.grade)> 3.89 ", sd.getHaving());
        assertEquals("order by avg(m.grade)", sd.getOrderBy());
    }
	
}
