/* 	SqlMetaDataTest.java
 *	Copyright (c) 2004-2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Feb 27, 2004
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * May 5, 2007	dennis@brains2b.nl       Use new ConnectedTestCase		
*/
package test.org.brains2b.sql.meta;

import java.sql.SQLException;
import java.util.List;

import org.brains2b.sql.meta.SQLMetaData;
import org.brains2b.sql.meta.TypesInfo;

/** Testcase for TableModel
 *  <p>This just returns the tests that are not covered
 *  by the individual model tests in this package.
 *  Tests here are limited because we cannot know which driver is used</p>
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.11 [May 5, 2007]
 * @see org.brains2b.sql.meta.SQLMetaData
 */
public class SqlMetaDataTest extends ConnectedTestCase {

	/**
	 * Constructor for SqlMetaDataTest.
	 * @param arg0
	 */
	public SqlMetaDataTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.swingui.TestRunner.run(SqlMetaDataTest.class);
	}

    public void testGetCatalogs() {
        try {
            SQLMetaData meta = new SQLMetaData(getConnector().getConnection());
            List l = meta.getCatalogs();
            assertNotNull(l);
        } catch (SQLException sqex) {
            assertTrue(sqex.getMessage(),false);
        }
    }
    
    public void testGetSchemas() {
        try {
            SQLMetaData meta = new SQLMetaData(getConnector().getConnection());
            List l = meta.getSchemas();
            assertNotNull(l);
        } catch (SQLException sqex) {
            assertTrue(sqex.getMessage(),false);
        }
    }
    
    public void testGetTableTypes() {
        try {
            SQLMetaData meta = new SQLMetaData(getConnector().getConnection());
            List l = meta.getTableTypes();
            assertNotNull(l);
            assertTrue(l.contains("TABLE"));
        } catch (SQLException sqex) {
            assertTrue(sqex.getMessage(),false);
        }
    }
    
    public void testgetSqlTypes() {
        try {
            SQLMetaData meta = new SQLMetaData(getConnector().getConnection());
            TypesInfo types = meta.getTypeInfo();
            assertNotNull(types);
        } catch (SQLException sqex) {
            assertTrue(sqex.getMessage(),false);
        }
    }
    
}
